import { Component, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema, SFDateWidgetSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { TicketService } from '../../../services/system.service';

@Component({
  selector: 'app-invoice-requested-detail',
  templateUrl: './invoice-requested-detail.component.html',
  styleUrls: ['./invoice-requested-detail.component.less']
})
export class InvoiceRequestedDetailComponent implements OnInit {
  url = `/rule?_allow_anonymous=true`;
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;
  columns: STColumn[] = [
    { title: '', index: 'key', type: 'checkbox' },
    { title: '运单号', index: 'no' },
    { title: '开票状态', index: 'callNo' },
    { title: '开票金额', index: 'callNo' },
    { title: '总费用', index: 'callNo' },
    { title: '基础运费', index: 'callNo' },
    { title: '附加费', index: 'callNo' },
    { title: '发票号码', index: 'callNo' },
    { title: '开票日期', index: 'updatedAt', type: 'date' }
  ];
  searchSchema: SFSchema = {
    properties: {
      orderSn: {
        type: 'string',
        title: '运单号',
        ui: {
          autocomplete: 'off'
        }
      },
      receiveName: {
        type: 'string',
        title: '开票状态',
        enum: [
          { label: '全部', value: '' },
          { label: '待受理', value: '待受理' },
          { label: '待开票', value: '待开票' },
          { label: '开票中', value: '开票中' },
          { label: '已开票', value: '已开票' },
          { label: '已撤销', value: '已撤销' },
          { label: '已拒绝', value: '已拒绝' }
        ],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName = i;
            this.sf?.setValue('/receiveName', i);
          }
        },
        default: ''
      },
      orderSn2: {
        type: 'string',
        title: '发票号码',
        ui: {
          placeholder: '请输入',
          autocomplete: 'off'
        }
      }
    }
  };

  reqParams = {};

  selectedRows: any[] = [];
  totalCallNo = 0;
  constructor(public service: TicketService, private nzModalService: NzModalService, private router: Router) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        this.totalCallNo = this.selectedRows.reduce((total, cv) => total + cv.callNo, 0);
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  goBack() {
    history.go(-1);
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
}
